/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.gui;

import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import org.visnow.vn.geometries.parameters.PointFieldRenderingParams;
import static org.visnow.vn.geometries.parameters.PointFieldRenderingParams.Selection.*;
import org.visnow.vn.geometries.viewer3d.eventslisteners.render.RenderEvent;
import org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeModel;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 *
 * GUI panel containing displayed points selection criteria (by subset or by component value) and
 * the size of the displayed points sample
 *
 * A slider controlling point size is present
 *
 */
public class PointFieldRenderingGUI extends javax.swing.JPanel
{

    protected PointFieldRenderingParams params;

    private static final String[] TABLE_HEADER = new String[]{"subset name", "size", "show"};
    private final DefaultTableModel subsetModel;
    private Object[][] tableContent = null;

    /**
     * Creates new form PointFieldRenderingGUI
     */
    public PointFieldRenderingGUI()
    {
        initComponents();
        subsetModel = (DefaultTableModel) subsetTable.getModel();
        subsetModel.addTableModelListener(new TableModelListener()
        {
            @Override
            public void tableChanged(TableModelEvent e)
            {
                int row = e.getFirstRow();
                if (row >= 0 && row < subsetTable.getRowCount() && params.getSubsetNames().length == subsetTable.getRowCount()) {
                    boolean[] modifiedSelection = params.getSubsetActive();
                    modifiedSelection[row] = (boolean) subsetTable.getValueAt(row, 2);
                    params.updateSubsetActive();
                }
            }
        });
        subsetPanel.setVisible(false);
        componentSubrangeUI.setVisible(false);
        emptyPreselectionWarningLabel.setVisible(false);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        lineWidthSlider = new javax.swing.JSlider();
        outlineBox = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        displayedRangeSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider();
        renderedPointsSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        colorEditor = new org.visnow.vn.gui.widgets.ColorEditor();
        selectorPanel = new javax.swing.JPanel();
        bySubsetsBtn = new javax.swing.JRadioButton();
        byRangeBtn = new javax.swing.JRadioButton();
        byCmpRangeBtn = new javax.swing.JRadioButton();
        componentSubrangeUI = new org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI();
        subsetPanel = new javax.swing.JPanel();
        subsetComponentChooser = new org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI();
        subsetSelectorPane = new javax.swing.JScrollPane();
        subsetTable = new javax.swing.JTable();
        emptyPreselectionWarningLabel = new javax.swing.JLabel();

        setBorder(javax.swing.BorderFactory.createEtchedBorder());
        setRequestFocusEnabled(false);
        setLayout(new java.awt.GridBagLayout());

        lineWidthSlider.setMajorTickSpacing(20);
        lineWidthSlider.setMinorTickSpacing(5);
        lineWidthSlider.setPaintTicks(true);
        lineWidthSlider.setValue(10);
        lineWidthSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("line/point width"));
        lineWidthSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                lineWidthSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(lineWidthSlider, gridBagConstraints);

        outlineBox.setText("show outline");
        outlineBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                outlineBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(outlineBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        displayedRangeSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder(null, "Displayed nodes range", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 14)))); // NOI18N
        displayedRangeSlider.setExtent(10);
        displayedRangeSlider.setPolicy(SubRangeModel.STOP);
        displayedRangeSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                displayedRangeSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(displayedRangeSlider, gridBagConstraints);

        renderedPointsSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.LONG);
        renderedPointsSlider.setGlobalMax(64000000);
        renderedPointsSlider.setMax(64000000);
        renderedPointsSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        renderedPointsSlider.setValue(1000000);
        renderedPointsSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "displayed nodes ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 14))); // NOI18N
        renderedPointsSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                renderedPointsSliderUserAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(renderedPointsSlider, gridBagConstraints);

        colorEditor.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                colorEditorStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.7;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 0);
        add(colorEditor, gridBagConstraints);

        selectorPanel.setLayout(new java.awt.GridLayout(3, 0));

        buttonGroup1.add(bySubsetsBtn);
        bySubsetsBtn.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        bySubsetsBtn.setText("choose subsets");
        bySubsetsBtn.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                bySubsetsBtnActionPerformed(evt);
            }
        });
        selectorPanel.add(bySubsetsBtn);

        buttonGroup1.add(byRangeBtn);
        byRangeBtn.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        byRangeBtn.setSelected(true);
        byRangeBtn.setText("point index range");
        byRangeBtn.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                byRangeBtnActionPerformed(evt);
            }
        });
        selectorPanel.add(byRangeBtn);

        buttonGroup1.add(byCmpRangeBtn);
        byCmpRangeBtn.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        byCmpRangeBtn.setText("component values range");
        byCmpRangeBtn.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                byCmpRangeBtnActionPerformed(evt);
            }
        });
        selectorPanel.add(byCmpRangeBtn);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        add(selectorPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(componentSubrangeUI, gridBagConstraints);

        subsetPanel.setLayout(new java.awt.BorderLayout());
        subsetPanel.add(subsetComponentChooser, java.awt.BorderLayout.NORTH);

        subsetSelectorPane.setPreferredSize(new java.awt.Dimension(200, 200));

        subsetTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][]
            {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String []
            {
                "name", "size", "show"
            }
        )
        {
            Class[] types = new Class []
            {
                java.lang.String.class, java.lang.Long.class, java.lang.Boolean.class
            };
            boolean[] canEdit = new boolean []
            {
                false, false, true
            };

            public Class getColumnClass(int columnIndex)
            {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex)
            {
                return canEdit [columnIndex];
            }
        });
        subsetSelectorPane.setViewportView(subsetTable);

        subsetPanel.add(subsetSelectorPane, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(subsetPanel, gridBagConstraints);

        emptyPreselectionWarningLabel.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        emptyPreselectionWarningLabel.setForeground(new java.awt.Color(153, 0, 51));
        emptyPreselectionWarningLabel.setText("<html>Warning: no nodes satisfying <p>this selection</html>");
        emptyPreselectionWarningLabel.setMaximumSize(new java.awt.Dimension(1000, 40));
        emptyPreselectionWarningLabel.setMinimumSize(new java.awt.Dimension(100, 40));
        emptyPreselectionWarningLabel.setName(""); // NOI18N
        emptyPreselectionWarningLabel.setOpaque(true);
        emptyPreselectionWarningLabel.setPreferredSize(new java.awt.Dimension(200, 40));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(emptyPreselectionWarningLabel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void lineWidthSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_lineWidthSliderStateChanged
    {//GEN-HEADEREND:event_lineWidthSliderStateChanged
        if (params != null)
            params.setPointSize(lineWidthSlider.getValue());
    }//GEN-LAST:event_lineWidthSliderStateChanged

    private void outlineBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_outlineBoxActionPerformed
    {//GEN-HEADEREND:event_outlineBoxActionPerformed
        colorEditor.setEnabled(outlineBox.isSelected());
        if (params != null)
            params.setOutline(outlineBox.isSelected());
    }//GEN-LAST:event_outlineBoxActionPerformed

    private void renderedPointsSliderUserAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_renderedPointsSliderUserAction
        if (params != null && !renderedPointsSlider.isAdjusting())
            params.setNDisplayedNodes(renderedPointsSlider.getValue().longValue());
    }//GEN-LAST:event_renderedPointsSliderUserAction

    private void displayedRangeSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_displayedRangeSliderStateChanged
        if (params != null && !displayedRangeSlider.isAdjusting()) {
            params.setFromTo(displayedRangeSlider.getLow(), displayedRangeSlider.getUp());
        }
    }//GEN-LAST:event_displayedRangeSliderStateChanged

    private void colorEditorStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_colorEditorStateChanged
        if (params != null)
            params.setColor(colorEditor.getColor());
    }//GEN-LAST:event_colorEditorStateChanged

    private void byRangeBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_byRangeBtnActionPerformed
    {//GEN-HEADEREND:event_byRangeBtnActionPerformed
        setSelectionMode();
    }//GEN-LAST:event_byRangeBtnActionPerformed

    private void bySubsetsBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_bySubsetsBtnActionPerformed
    {//GEN-HEADEREND:event_bySubsetsBtnActionPerformed
        setSelectionMode();
    }//GEN-LAST:event_bySubsetsBtnActionPerformed

    private void byCmpRangeBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_byCmpRangeBtnActionPerformed
    {//GEN-HEADEREND:event_byCmpRangeBtnActionPerformed
        setSelectionMode();
    }//GEN-LAST:event_byCmpRangeBtnActionPerformed

    private void setSelectionMode()
    {
        if (byRangeBtn.isSelected())
            params.setSelectBy(INDEX);
        else if (bySubsetsBtn.isSelected())
            params.setSelectBy(SUBSET);
        else if (byCmpRangeBtn.isSelected())
            params.setSelectBy(COMPONENT);
        updateSelectionWidgets();
        params.fireStateChanged(RenderEvent.GEOMETRY);
    }

    public void setPreselectedNodes()
    {
        boolean atMax = params.getNNodes() >= .99 * (long)renderedPointsSlider.getMax();
        long nPreselectedNodes = Math.min(100000000L, params.getNPreselectedNodes());
        renderedPointsSlider.setAllMinMax(Math.max(10, nPreselectedNodes / 100000), nPreselectedNodes,
                                          Math.max(10, nPreselectedNodes / 100000), nPreselectedNodes);

        params.setNDisplayedNodes(atMax ?
                                  nPreselectedNodes :
                                  Math.min(params.getNNodes(), nPreselectedNodes));
        renderedPointsSlider.setValue(params.getNNodes());
    }

    private void updateSelectionWidgets()
    {
        displayedRangeSlider.setVisible(params.getSelectBy() == INDEX);
        subsetPanel.setVisible(params.getSelectBy()   == SUBSET);
        componentSubrangeUI.setVisible(params.getSelectBy()  == COMPONENT);
    }

    public void setParams(PointFieldRenderingParams params)
    {
        this.params = params;
        updateDataValuesFromParams();
        params.setGui(this);
        componentSubrangeUI.setComponentValue(params.getValRange());
        subsetComponentChooser.setComponentFeature(params.getByteComponentsParam());
    }

    public void setWarning(boolean show)
    {
        emptyPreselectionWarningLabel.setVisible(show);
    }

    public void updateDataValuesFromParams()
    {
        if (params.getSubsetNames() != null && params.getSubsetNames().length > 0) {
            bySubsetsBtn.setVisible(true);
            int nSubsets = params.getSubsetNames().length;
            tableContent = new Object[nSubsets][3];
            for (int i = 0; i < nSubsets; i++) {
                tableContent[i][0] = params.getSubsetNames()[i];
                tableContent[i][1] = params.getSubsetSizes()[i];
                tableContent[i][2] = params.getSubsetActive()[i];
            }
            subsetModel.setDataVector(tableContent, TABLE_HEADER);
            subsetTable.setModel(subsetModel);
            subsetSelectorPane.repaint();
            bySubsetsBtn.setSelected(params.getSelectBy() == SUBSET);
        }
        else {
            if (params.getSelectBy() == SUBSET)
                params.setSelectBy(INDEX);
            bySubsetsBtn.setVisible(false);
        }
        setPreselectedNodes();
        updateSelectionWidgets();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.ButtonGroup buttonGroup1;
    protected javax.swing.JRadioButton byCmpRangeBtn;
    protected javax.swing.JRadioButton byRangeBtn;
    protected javax.swing.JRadioButton bySubsetsBtn;
    protected org.visnow.vn.gui.widgets.ColorEditor colorEditor;
    protected org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI componentSubrangeUI;
    protected org.visnow.vn.gui.widgets.SubRangeSlider.ExtendedSubRangeSlider displayedRangeSlider;
    protected javax.swing.JLabel emptyPreselectionWarningLabel;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JSlider lineWidthSlider;
    protected javax.swing.JCheckBox outlineBox;
    protected org.visnow.vn.gui.widgets.ExtendedSlider renderedPointsSlider;
    protected javax.swing.JPanel selectorPanel;
    protected org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI subsetComponentChooser;
    protected javax.swing.JPanel subsetPanel;
    protected javax.swing.JScrollPane subsetSelectorPane;
    protected javax.swing.JTable subsetTable;
    // End of variables declaration//GEN-END:variables

}
